/*
 * leds.c
 *
 *  Created on: Apr 28, 2018
 *      Author: wn
 */

#include <msp430g2553.h>
#include <stdint.h>

#include "leds.h"


void ledsInit() {
	ROW_OUT = 0;
	ROW_DIR |= ROW1 | ROW2 | ROW3;

	COL_OUT = 0;
	COL_DIR |= COL1_GREEN | COL2_GREEN | COL3_GREEN |
			COL1_RED | COL2_RED | COL3_RED;
}

void ledsShowField(tCellState *field) {
	for (uint8_t row = 0; row < ROW_SIZE; row++) {

		uint8_t rowOut = 0xff;
		if (row == 0) {
			rowOut &= ~ROW1;
		} else if (row == 1) {
			rowOut &= ~ROW2;
		} else if (row == 2) {
			rowOut &= ~ROW3;
		}

		uint8_t colOut = 0;
		for (uint8_t col = 0; col < COL_SIZE; col++) {
			uint8_t cell = field[(row * ROW_SIZE) + col];
			if (col == 0) {
				if (cell == csCIRCLE) {
					colOut |= COL1_RED;
				} else if (cell == csCROSS) {
					colOut |= COL1_GREEN;
				}
			} else if (col == 1) {
				if (cell == csCIRCLE) {
					colOut |= COL2_RED;
				} else if (cell == csCROSS) {
					colOut |= COL2_GREEN;
				}
			} else if (col == 2) {
				if (cell == csCIRCLE) {
					colOut |= COL3_RED;
				} else if (cell == csCROSS) {
					colOut |= COL3_GREEN;
				}
			}
		}

		ROW_OUT = rowOut;
		COL_OUT = colOut;
	}
}
